/*
 * The UDS Collection
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _uds_btrace_hh
#define _uds_btrace_hh


// includes

#include <string>


namespace uds
{

using namespace std;


/** generates a backtrace. Symbols are resolved if possible.
	\param res 'resolve symbols' flag. If this flag is set to true
	and debugging information is available, source file names,
	line numbers, and function names are printed instead of
	memory addresses.
	If the executable is not linked statically, not all symbols
	can be resolved.
	\param lb break lines to fit into 79 columns if this parameter
	is true */
string
Backtrace( bool res = true, bool lb = true );

}

#endif // _uds_btrace_hh
