/*
 * The UDS Collection
 * Copyright (C) 1999, 2000, 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _uds_exit_hh
#define _uds_exit_hh


// includes

#include <exception>
#include <cstdlib>


namespace uds
{

using namespace std;


/** exit "exception" class. Don't worry... everything is ok ;-)
	\author Julian v. Bock */
class Exit_t
{	
public:
	/** \param rv return value */
	Exit_t( int rv ) : retval( rv ) {}
	
	/** destructor */
	virtual
	~Exit_t() {}
	
	/** \return return value */
	int
	ReturnValue() const { return retval; }
	
private:
	/// return value
	int 	retval;
};

/** exits _with_ stack unwinding etc. However, you should not forget to catch
	uds::Exit_t in the main function
	\param rv return value */
inline void
Exit( int rv )
{
	if ( !uncaught_exception() )
		throw uds::Exit_t( rv );
	
	// _not_ good...
	exit( rv );
}

}


#endif // _uds_exit_hh
