/*
 * The UDS Collection
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _uds_init_hh
#define _uds_init_hh


namespace uds
{

/** UDS initialization class. You should place one instance in your main
	function. Right now this class serves only one purpose: If the instance
	was not created, it is assumed that an exception might not be caught in
	case of a fatal error. Therefore an error message is printed to stderr
	before the exception is thrown.
	\author Julian v. Bock */
class Init
{
public:
	/** default constructor */
	Init();
	
	/** destructor */
	~Init();
	
private:
	/// forbidden
	void*
	operator new ( unsigned int );
};


/** \return true if the UDS library was initialized */
bool
Initialized();

}

#endif // _uds_init_hh
