/*
 * The UDS Collection
 * Copyright (C) 2000, 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#if !defined _uds_thread_nreent_hh && !defined _uds_thread_nreent_hh_dox_hack
#define _uds_thread_nreent_hh

// this is an internal UDS header. don't include it directly.

#ifdef _REENTRANT
#error "you must not #define _REENTRANT"
#endif


// includes

#include <sys/types.h>


namespace uds
{

/** mutex class. Note: the mutex methods are all const so you don't have to
	make them mutable to protect const operations.
	this class is only a dummy.
	\author Julian v. Bock */
class Mutex
{
public:
	/** \param t mutex type */
	Mutex() {}
	
	/** destructor */
	~Mutex() {}
	
	/** locks the mutex */
	void
	Lock() const {}
	
	/** tries to lock the mutex
		\return 0 on success, otherwise an error code */
	int
	TryLock() const { return 0; }
	
	/** unlocks the mutex */
	void
	UnLock() const {}
};

/** mutex lock class. this class is only a dummy.
	\author Julian v. Bock */
class MutexLock
{
public:
	/** \param m mutex */
	MutexLock( const Mutex& m ) {}
	
	/** destructor */
	~MutexLock() {}
	
private:
	void*
	operator new ( size_t );
};

/** mutex lock class. makes sure that the mutex gets unlocked even if the
	thread is cancelled before the lock class is destroyed.
	this class is only a dummy.
	\author Julian v. Bock */
class CMutexLock
{
public:
	/** \param m mutex */
	CMutexLock( const Mutex& m ) {}
	
	/** destructor */
	~CMutexLock() {}
	
private:
	void*
	operator new ( size_t );
};

}

#endif // _uds_thread_nreent_hh
