dnl checks for the default user
dnl
dnl arg1: default user

AC_DEFUN(UDS_CHECK_DEFUSER, [
withval=$1
test "$withval" || withval=no
AC_MSG_CHECKING(for default user)
AC_ARG_WITH(default-user, [  --with-default-user=u   default user])
case "$withval" in
	yes)
		echo
		echo "*** invalid option to --with-default-user"
		echo "*** use --without-default-user or --with-default-user=user"
		echo
		exit 1
		;;
	no)
		uds_defuser=
		uds_msg="no default user"
		;;
	*)
		uds_defuser=$withval
		uds_msg=$withval
		;;
esac
AC_MSG_RESULT($uds_msg)
AC_DEFINE_UNQUOTED(DEFAULT_USER,"${uds_defuser}",default user)
AC_SUBST(uds_defuser)
])


dnl checks for the default group
dnl
dnl arg1: default group

AC_DEFUN(UDS_CHECK_DEFGROUP, [
withval=$1
test "$withval" || withval=no
AC_MSG_CHECKING(for default group)
AC_ARG_WITH(default-group, [  --with-default-group=g  default group])
case "$withval" in
	yes)
		echo
		echo "*** invalid option to --with-default-group"
		echo "*** use --without-default-group or --with-default-group=group"
		echo
		exit 1
		;;
	no)
		uds_defgroup=
		uds_msg="no default group"
		;;
	*)
		uds_defgroup=$withval
		uds_msg=$withval
		;;
esac
AC_MSG_RESULT($uds_msg)
AC_DEFINE_UNQUOTED(DEFAULT_GROUP,"${uds_defgroup}",default group)
AC_SUBST(uds_defgroup)
])


dnl checks for runtime variable data directory
dnl
dnl arg1: extra default directory

AC_DEFUN(UDS_CHECK_VARRUNDIR, [
AC_REQUIRE([UDS_PATHS])

withval=$uds_localstatedir/run
test "$1" && withval="$withval/$1"
AC_MSG_CHECKING(for runtime variable data directory)
AC_ARG_WITH(var-run-dir, [  --with-var-run-dir=dir  runtime var data directory])
varrundir="$withval"
varrundir=$(echo $varrundir | sed 's-/$--')
AC_MSG_RESULT($varrundir)
AC_DEFINE_UNQUOTED(VARRUNDIR,"${varrundir}",lockfile directory)
AC_SUBST(varrundir)
])
