dnl debug check
dnl
dnl arg1: default compiler debug option

AC_DEFUN(UDS_CHECK_DEBUG, [
AC_REQUIRE([UDS_FL_INIT])

enableval=yes
AC_MSG_CHECKING(whether to create debug info)
AC_ARG_ENABLE(debug,[  --enable-debug(=type)   compile with debug info])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	if test "$enableval" = "yes"; then
		uds_optflags="-g"
	else
		uds_optflags="-$enableval"
	fi
	uds_debug=yes
	uds_ndebug=no
	AC_DEFINE(DEBUG,,[build debug info])
else
	AC_MSG_RESULT(no)
	uds_debug=no
	uds_ndebug=yes
fi
])


dnl static link check

AC_DEFUN(UDS_CHECK_STATIC_LINK, [
AC_REQUIRE([UDS_CHECK_DEBUG])

enableval=no
AC_MSG_CHECKING(whether to link against static libraries)
AC_ARG_ENABLE(static,[  --enable-static         link against static libraries])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	LDFLAGS="$LDFLAGS -static"
	AC_DEFINE(STATIC,,[link to static libraries])
else
	AC_MSG_RESULT(no)
fi
])
