dnl checks which default flags to set.
dnl default values are chosen depending on the uds_debug variable

AC_DEFUN(UDS_CHECK_FLAGS, [
AC_REQUIRE([UDS_CHECK_DEBUG])

enableval=no
AC_MSG_CHECKING(whether to force core dumps on fatal errors)
AC_ARG_ENABLE(core-dumps,[  --enable-core-dumps     dump the core on fatal errors])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_FORCE_CORE_DUMPS,,[force core dumps on fatal errors])
else
	AC_MSG_RESULT(no)
fi

enableval=$uds_debug
AC_MSG_CHECKING(whether to check for memory leaks)
AC_ARG_ENABLE(leak-check,[  --enable-leak-check     check for memory leaks])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_LEAK_CHECK,,[check for memory leaks])
else
	AC_MSG_RESULT(no)
fi

enableval=$uds_debug
AC_MSG_CHECKING(whether to create zombie objects)
AC_ARG_ENABLE(zombies,[  --enable-zombies        create zombie objects])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_SUMMON_ZOMBIES,,[create zombie objects])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to log memory allocations)
AC_ARG_ENABLE(log-allocs,[  --enable-log-allocs     log memory allocations])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_LOG_ALLOCS,,[log memory allocations])
else
	AC_MSG_RESULT(no)
fi

enableval=$uds_debug
AC_MSG_CHECKING(whether to rename uds coredumps)
AC_ARG_ENABLE(rename-cores,[  --enable-rename-cores   rename uds coredumps])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_RENAME_UDS_CORES,,[rename uds coredumps])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to generate backtraces on non-fatal errors)
AC_ARG_ENABLE(std-backtraces,[  --enable-std-backtraces generate backtraces on non-fatal errors])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_STD_BACKTRACES,,[generate backtraces on non-fatal errors])
else
	AC_MSG_RESULT(no)
fi
])


dnl checks which default flags to set.
dnl all options default to 'no'

AC_DEFUN(UDS_CHECK_FLAGS_ND, [
enableval=no
AC_MSG_CHECKING(whether to force core dumps on fatal errors)
AC_ARG_ENABLE(core-dumps,[  --enable-core-dumps     dump the core on fatal errors])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_FORCE_CORE_DUMPS,,[force core dumps on fatal errors])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to check for memory leaks)
AC_ARG_ENABLE(leak-check,[  --enable-leak-check     check for memory leaks])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_LEAK_CHECK,,[check for memory leaks])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to create zombie objects)
AC_ARG_ENABLE(zombies,[  --enable-zombies        create zombie objects])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_SUMMON_ZOMBIES,,[create zombie objects])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to log memory allocations)
AC_ARG_ENABLE(log-allocs,[  --enable-log-allocs     log memory allocations])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_LOG_ALLOCS,,[log memory allocations])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to rename uds coredumps)
AC_ARG_ENABLE(rename-cores,[  --enable-rename-cores   rename uds coredumps])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_RENAME_UDS_CORES,,[rename uds coredumps])
else
	AC_MSG_RESULT(no)
fi

enableval=no
AC_MSG_CHECKING(whether to generate backtraces on non-fatal errors)
AC_ARG_ENABLE(std-backtraces,[  --enable-std-backtraces generate backtraces on non-fatal errors])
if test "$enableval" != "no"; then
	AC_MSG_RESULT(yes)
	AC_DEFINE(UDS_STD_BACKTRACES,,[generate backtraces on non-fatal errors])
else
	AC_MSG_RESULT(no)
fi
])
