dnl optimization check macro
dnl
dnl arg1: extra standard optimization options
dnl arg2: extra speed optimization options
dnl arg3: extra size optimization options

AC_DEFUN(UDS_CHECK_OPTIMIZATION, [
AC_REQUIRE([UDS_CHECK_DEBUG])

uds_fast_lexer=$uds_ndebug
enableval=yes
AC_MSG_CHECKING(whether to enable optimizations)
AC_ARG_ENABLE(optimization,[  --enable-optimization   enable optimizations])
case "$enableval" in
	yes)
		AC_MSG_RESULT(standard)
		uds_optflags="$uds_optflags -O2 $1"
		uds_fast_lexer=yes
		;;
	speed)
		AC_MSG_RESULT(speed)
		uds_optflags="$uds_optflags -O3 $2"
		uds_arch=yes
		uds_fast_lexer=yes
		;;
	size)
		AC_MSG_RESULT(size)
		uds_optflags="$uds_optflags -Os $3"
		uds_arch=yes
		uds_fast_lexer=no
		;;
	no)
		AC_MSG_RESULT(no)
		;;
	*)
		echo
		echo "*** invalid option to --enable-optimization"
		echo "*** use one of speed, size, yes, no"
		echo
		exit 1
		;;
esac

enableval=$uds_arch
AC_MSG_CHECKING(for which archtitecture to optimize)
AC_ARG_ENABLE(arch,[  --enable-arch(=arch)    optimize for architecture arch])
case "$enableval" in
	yes)
		m=`uname -m`
		case $m in
			i?86 | k6)
				AC_MSG_RESULT($m)
				uds_optflags="$uds_optflags -march=$m"
				;;
			*)
				AC_MSG_RESULT(default)
				;;
		esac
		;;
	no)
		AC_MSG_RESULT(default)
		;;
	*)
		AC_MSG_RESULT($enableval)
		uds_optflags="$uds_optflags -march=$enableval"
		;;
esac
])
