dnl defines some paths for use in configure scripts and programs

AC_DEFUN(UDS_PATHS, [
echo "retrieving target directories"

eval uds_prefix=$(echo $prefix | sed s#NONE#"$ac_default_prefix"#)
eval uds_exec_prefix=$(echo $exec_prefix | sed s#NONE#"$uds_prefix"#)

for v in datadir sysconfdir sharedstatedir localstatedir includedir \
	infodir mandir
do
	val=$(eval echo '$'$v)
	val=$(echo $val | sed s#'${prefix}'#"$uds_prefix"#)
	eval uds_$v=$val
done

for v in bindir sbindir libexecdir libdir
do
	val=$(eval echo '$'$v)
	val=$(echo $val | sed s#'${exec_prefix}'#"$uds_exec_prefix"#)
	eval uds_$v=$val
done
	

AC_DEFINE_UNQUOTED(PREFIX,"$uds_prefix",[prefix directory])
AC_DEFINE_UNQUOTED(EXEC_PREFIX,"$uds_exec_prefix",[exec prefix directory])
AC_DEFINE_UNQUOTED(BINDIR,"$uds_bindir",[bin directory])
AC_DEFINE_UNQUOTED(SBINDIR,"$uds_sbindir",[sbin directory])
AC_DEFINE_UNQUOTED(LIBEXECDIR,"$uds_libexecdir",[libexec directory])
AC_DEFINE_UNQUOTED(DATADIR,"$uds_datadir",[data directory])
AC_DEFINE_UNQUOTED(SYSCONFDIR,"$uds_sysconfdir",[config file directory])
AC_DEFINE_UNQUOTED(SHAREDSTATEDIR,"$uds_sharedstatedir",[shared state directory])
AC_DEFINE_UNQUOTED(LOCALSTATEDIR,"$uds_localstatedir",[local state directory])
AC_DEFINE_UNQUOTED(LIBDIR,"$uds_libdir",[library directory])
AC_DEFINE_UNQUOTED(INFODIR,"$uds_infodir",[info directory])
AC_DEFINE_UNQUOTED(MANDIR,"$uds_mandir",[man directory])
AC_DEFINE_UNQUOTED(INCLUDEDIR,"$uds_includedir",[include directory])
])
