dnl profiling check macro

AC_DEFUN(UDS_CHECK_PROFILE, [
AC_REQUIRE([UDS_FL_INIT])

enableval=no
AC_MSG_CHECKING(whether to enable profiling)
AC_ARG_ENABLE(profiling,[  --enable-profiling=opt  compile with profiling support])
case "$enableval" in
	both)
		AC_MSG_RESULT(flat profile and line coverage)
		uds_prof="-pg -fprofile-arcs -ftest-coverage"
		;;
	flat)
		AC_MSG_RESULT(flat profile)
		uds_prof="-pg"
		;;
	lcov)
		AC_MSG_RESULT(line coverage)
		uds_prof="-fprofile-arcs -ftest-coverage"
		;;
	no)
		AC_MSG_RESULT(no)
		uds_prof=
		;;
	*)
		echo
		echo
		echo "*** invalid option to --enable-profiling. must be one"
		echo "*** of both, flat, lcov, no"
		echo
		exit 1
		;;
esac
if test "$enableval" = flat -o "$enableval" = both; then
	AC_DEFINE(FPROFILE,,[generate profiling info for flat profile])
fi
test "$uds_prof" && uds_addflags="$uds_addflags $uds_prof"
])
